define([
    'jquery',
    'jquery/ui'
], function($) {
    'use strict';

    // creating jquery widget
    $.widget('filoblu.svgclip', {

        _create: function() {
            this._super();

            this.initElementFromPoint();
            this.clipLogo();
        },
        initElementFromPoint: function() {
            var check = !1,
                isRelative = !0;
            $.elementFromPoint = function(x, y) {
                if (!document.elementFromPoint)
                    return null;
                var sl;
                check || (0 < (sl = $(document).scrollTop()) ? isRelative = null == document.elementFromPoint(0, sl + $(window).height() - 1) : 0 < (sl = $(document).scrollLeft()) && (isRelative = null == document.elementFromPoint(sl + $(window).width() - 1, 0)),
                    check = 0 < sl);
                return isRelative || (x += $(document).scrollLeft(),
                        y += $(document).scrollTop()),
                    document.elementFromPoint(x, y)
            }
        },
        clipLogo: function() {

            "undefined" == typeof window.$M && (window.$M = {});
            var $currentElement = this.element,
                $logoClipOptions = {
                    image_1: this.options.image_1, // logo-black-clip-rect-1
                    image_2: this.options.image_2, // logo-black-clip-rect-2
                    image_3: this.options.image_3, // logo-colored-clip-rect
                    type: this.options.type, // type of element (img, iframe, picture, ...)
                    class: this.options.class // if the widget has to work on a particular class
                    //not_image: ".not-hover-logo"
                },
                $logoWidthProportionRule, //svg data-width
                $logoHeightProportionRule; ////svg data-height

            function manageLogoClip() {
                /* the function finds the logo if it is in a <svg> tag inside an <div> tag parent.
                 * If you want to put it into another element, just change .find("svg") with the new tag
                 * and remember to add the "margin-top" style to the element in the phtml.
                 */
                if (void 0 !== $.elementFromPoint) {
                    var elementBelowLogo_top_right, elementBelowLogo_bottom_right, elementBelowLogo_top_left, elementBelowLogo_bottom_left, elementBelowLogo_right, elementBelowLogo_left, topIsImage_right, topIsImage_left, bottomIsImage_right, bottomIsImage_left,
                    svgLogoSelector = $currentElement.find("svg"),
                    logoOffset = $currentElement.position(),
                    logoTop = logoOffset.top /*+ parseInt($($currentElement).find("svg").css("margin-top"))*/,
                    logoRight = logoOffset.left + ($(svgLogoSelector).outerWidth(!0) - 1),
                    logoLeft = logoOffset.left - ($(svgLogoSelector).outerWidth(!0) - 1),
                    /* aggiunto */
                    logoBottom = logoTop + ($(svgLogoSelector).outerHeight(!0) - 1),
                    boundaries = {};
                    if ($currentElement.css({
                            "pointer-events": "none"
                        }),
                        elementBelowLogo_top_right = $($.elementFromPoint(logoRight, logoTop)),
                        elementBelowLogo_bottom_right = $($.elementFromPoint(logoRight, logoBottom)),
                        elementBelowLogo_top_left = $($.elementFromPoint(logoLeft, logoTop)),
                        elementBelowLogo_bottom_left = $($.elementFromPoint(logoLeft, logoBottom)),
                        $currentElement.removeAttr("style"),
                        topIsImage_right = detectImage(elementBelowLogo_top_right),
                        bottomIsImage_right = detectImage(elementBelowLogo_bottom_right),
                        topIsImage_left = detectImage(elementBelowLogo_top_left),
                        bottomIsImage_left = detectImage(elementBelowLogo_bottom_left),
                        elementBelowLogo_top_right.is($logoClipOptions.type) && elementBelowLogo_top_right.parent().is($logoClipOptions.type) && (elementBelowLogo_top_right = elementBelowLogo_top_right.parent()),
                        elementBelowLogo_bottom_right.is($logoClipOptions.type) && elementBelowLogo_bottom_right.parent().is($logoClipOptions.type) && (elementBelowLogo_bottom_right = elementBelowLogo_bottom_right.parent()),
                        elementBelowLogo_top_left.is($logoClipOptions.type) && elementBelowLogo_top_left.parent().is($logoClipOptions.type) && (elementBelowLogo_top_left = elementBelowLogo_top_left.parent()),
                        elementBelowLogo_bottom_left.is($logoClipOptions.type) && elementBelowLogo_bottom_left.parent().is($logoClipOptions.type) && (elementBelowLogo_bottom_left = elementBelowLogo_bottom_left.parent())
                        /*elementBelowLogo_top_right.hasClass("not-hover-logo") && (topIsImage_right = !1),
                                         elementBelowLogo_bottom_right.hasClass("not-hover-logo") && (bottomIsImage_right = !1),*/
                        /*(!topIsImage_right && !bottomIsImage_right),
                        !topIsImage_left && !bottomIsImage_left*/
                    ) return elementsSetAttributes({
                        element: $logoClipOptions.image_1,
                        options: {
                            width: 0
                        }
                    }), elementsSetAttributes({
                        element: $logoClipOptions.image_2,
                        options: {
                            x: 0,
                            y: 0,
                            width: $logoWidthProportionRule,
                            height: $logoHeightProportionRule
                        }
                    }), void elementsSetAttributes({
                        element: $logoClipOptions.image_3,
                        options: {
                            x: 0,
                            y: 0,
                            width: 0,
                            height: 0
                        }
                    });
                    /* "logo" is the class of the svg <a> parent. */
                    elementBelowLogo_top_right.get(0) === elementBelowLogo_bottom_right.get(0) && (bottomIsImage_right = !1),
                    elementBelowLogo_top_left.get(0) === elementBelowLogo_bottom_left.get(0) && (bottomIsImage_left = !1),
                    $.extend(boundaries, getBoundaries(svgLogoSelector, "logo", !0)),
                    $.extend(boundaries, getBoundaries(elementBelowLogo_top_right, "fromBelow", topIsImage_right),
                        getBoundaries(elementBelowLogo_bottom_right, "fromTop", bottomIsImage_right)),
                    $.extend(boundaries, getBoundaries(elementBelowLogo_top_left, "fromBelow", topIsImage_left),
                        getBoundaries(elementBelowLogo_bottom_left, "fromTop", bottomIsImage_left)),
                    function(elements) {
                        Object.keys(elements).length;
                        $.each(elements, function(key, value) {
                            var blackY, colorY, rectHeight, blackHeight, colorHeight, finalHeight, rectWidth, blackWidth, colorWidth, flag = 0,
                            /* the flag is to determine if the logo has to be cut from the left or from the right */
                            /* proportionedWidth and proportionedHeight are the real dimension of the $currentElement */
                            /* rectWidth is the part that cut the element */
                            proportionedWidth = $currentElement.find("svg").outerWidth(!0),
                            proportionedHeight = $currentElement.find("svg").outerHeight(!0);

                            /* elements.logo.right is the distance between the left point of the screen and the right end of the element.
                             * elements.logo.left is the distance between the left point of the screen and the left end of the element.
                             * value.left is the distance between the left side of the DOM element and the left point of the screen.
                             * value.right is the distance between the right side of the DOM element and the left point of the screen.
                             */
                            if ((elements.logo.right - value.left) > proportionedWidth) { //right
                                rectWidth = (elements.logo.right - value.right) > 0 ? elements.logo.right - value.right : proportionedWidth;
                                colorWidth = makeTheProportion($logoWidthProportionRule, elements.logo.right - elements.logo.left - rectWidth, proportionedWidth);
                                blackWidth = makeTheProportion($logoWidthProportionRule, rectWidth, proportionedWidth);
                                flag = 1;
                            }
                            else { //left
                                rectWidth = (elements.logo.right - value.left) > 0 ? elements.logo.right - value.left : proportionedWidth;
                                blackWidth = makeTheProportion($logoWidthProportionRule, elements.logo.right - elements.logo.left - rectWidth, proportionedWidth);
                                colorWidth = makeTheProportion($logoWidthProportionRule, rectWidth, proportionedWidth);
                                flag = 0;
                            }

                            colorWidth = (rectWidth == proportionedWidth) && (blackWidth == $logoWidthProportionRule) ? $logoWidthProportionRule : colorWidth;

                            if ("logo" == key) return !0;
                            /* this part of code is to determine the height of the logo and the part being cut */
                            finalHeight = "fromTop" == key ? elements.logo.bottom - value.top : value.bottom - elements.logo.top,
                            rectHeight = proportionedHeight <= finalHeight ? proportionedHeight : finalHeight <= 0 ? 0 : finalHeight,
                            "fromTop" == key && (
                                blackY = 0,
                                blackHeight = makeTheProportion($logoHeightProportionRule, value.top - elements.logo.top, proportionedHeight),
                                colorY = blackHeight,
                                colorHeight = makeTheProportion($logoHeightProportionRule, rectHeight, proportionedHeight)
                            ),
                            "fromBelow" == key && (
                                blackY = makeTheProportion($logoHeightProportionRule, rectHeight, proportionedHeight),
                                blackHeight = makeTheProportion($logoHeightProportionRule, elements.logo.bottom - value.bottom, proportionedHeight),
                                colorY = 0,
                                colorHeight = makeTheProportion($logoHeightProportionRule, rectHeight, proportionedHeight)
                            );
                            if (flag == 0) { /* left cut */
                                elementsSetAttributes({
                                    element: $logoClipOptions.image_1,
                                    options: {
                                        width: blackWidth
                                    }
                                }), elementsSetAttributes({
                                    element: $logoClipOptions.image_2,
                                    options: {
                                        x: blackWidth,
                                        y: blackY,
                                        width: colorWidth,
                                        height: blackHeight < 0 ? 0 : blackHeight
                                    }
                                }), elementsSetAttributes({
                                    element: $logoClipOptions.image_3,
                                    options: {
                                        x: blackWidth,
                                        y: colorY,
                                        width: colorWidth,
                                        height: colorHeight < 0 ? 0 : colorHeight
                                    }
                                });
                            }
                            else { /* right cut */
                                elementsSetAttributes({
                                    element: $logoClipOptions.image_1,
                                    options: {
                                        x: colorWidth,
                                        width: blackWidth
                                    }
                                }), elementsSetAttributes({
                                    element: $logoClipOptions.image_2,
                                    options: {
                                        y: blackY,
                                        width: colorWidth,
                                        height: blackHeight < 0 ? 0 : blackHeight
                                    }
                                }), elementsSetAttributes({
                                    element: $logoClipOptions.image_3,
                                    options: {
                                        y: colorY,
                                        width: colorWidth,
                                        height: colorHeight < 0 ? 0 : colorHeight
                                    }
                                });
                            }
                        })
                    }(boundaries);
                    clearDefaults(topIsImage_right, bottomIsImage_right , topIsImage_left, bottomIsImage_left);
                }
            }

            /*
             * detectImage: on what the clipping should happen.
             */

            function detectImage(element) {
                return (element.is($logoClipOptions.type) || element.hasClass($logoClipOptions.class)); /*|| element.hasClass("FiloBlu-widget-image") || element.hasClass("site-widget-image")) && !element.hasClass("menu-logo")*/
            }

            function getBoundaries(element, key, flag) {
                var object = {};
                return flag && (object[key] = {
                    top: element.offset().top,
                    bottom: element.offset().top + element.height(),
                    left: element.offset().left,
                    right: element.offset().left + element.outerWidth(!0)
                }), object
            }

            function makeTheProportion(proportionrule, number1, number2) {
                var proportionedResult = proportionrule * (number1 / number2);
                return proportionedResult < 0 && (proportionedResult = 0), proportionedResult
            }

            function elementsSetAttributes(object) {
                if (void 0 !== object.element && void 0 !== object.options) {
                    var element = object.element;
                    $.each(object.options, function(key, value) {
                        $(element).attr(key, value)
                    })
                }
            }

            function clearDefaults(topIsImage_right, bottomIsImage_right, topIsImage_left, bottomIsImage_left) {
                if (!topIsImage_right && !bottomIsImage_right && !topIsImage_left && !bottomIsImage_left) {
                    elementsSetAttributes({
                        element: $logoClipOptions.image_1,
                        options: {
                            width: 0
                        }
                    }), elementsSetAttributes({
                        element: $logoClipOptions.image_2,
                        options: {
                            x: 0,
                            y: 0,
                            width: $logoWidthProportionRule,
                            height: $logoHeightProportionRule
                        }
                    }), void elementsSetAttributes({
                        element: $logoClipOptions.image_3,
                        options: {
                            x: 0,
                            y: 0,
                            width: 0,
                            height: 0
                        }
                    })
                }
            }

            window.$M.logoclip = function(element) {
                if (void 0 !== element) {
                    try {
                        $logoWidthProportionRule = parseInt($currentElement.find("svg").data("width")),
                        $logoHeightProportionRule = parseInt($currentElement.find("svg").data("height"));
                        var timer;
                        manageLogoClip(),
                            $(window).on("resize.logoclip", function(e) {
                                manageLogoClip()
                            }),
                            $(window).on("scroll.logoclip", function(e) {
                                manageLogoClip()
                            });
                    } catch (e) {
                        console.error(e.message), console.error(e)
                    }
                }
            }

            return window.$M.logoclip($currentElement);
        }
    });

    return $.filoblu.svgclip;
});
